<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 01/14/2013 *
 * ===================                          Last change: 01/14/2013 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : mode-update.php                                  *
 * -------------------------------------------------------------------- *
 * Short description : Bonus pages                                      *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Bonus-Seiten                                     *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2013 by Mailer Developer Team                   *
 * For more information visit: http://mxchange.org                      *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} // END - if

// @TODO Remove double tabs from all lines
		switch (getCurrentExtensionVersion()) {
			case '0.1.6': // SQL queries for v0.1.6
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Paid-Links wurden verschoben in die Erweiterung <strong>sponsor</strong>.");
				break;

			case '0.2.0': // SQL queries for v0.2.0
				addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_bonus` SET `target_send`=`mails_sent` WHERE `target_send`=0 AND `mails_sent`>0 AND `receivers` != ''");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Behebt ein Versand-Problem mit den Bonus-Mails. Es wurde die Spalte target_send nicht beim Einf&uuml;gen der Buchung gessetzt.");
				break;

			case '0.2.1': // SQL queries for v0.2.1
				// Add extension dependency to ex-tuser because of the ALTER command
				addExtensionDependency('user');

				addConfigAddSql('login_bonus', 'FLOAT(20,3) NOT NULL DEFAULT 10.000');
				addConfigAddSql('turbo_bonus', 'FLOAT(20,3) NOT NULL DEFAULT 100.000');
				addConfigAddSql('login_timeout', 'BIGINT(20) UNSIGNED NOT NULL DEFAULT {?ONE_DAY?}');
				addConfigAddSql('turbo_rates', "VARCHAR(255) NOT NULL DEFAULT '50;20;10'");
				addConfigAddSql('bonus_ranks', 'TINYINT(3) UNSIGNED NOT NULL DEFAULT 10');

				// Use actual month for this update
				addExtensionAddTableColumnSql('user_data', 'login_bonus', 'FLOAT(20,3) NOT NULL DEFAULT 0.000');
				addExtensionAddTableColumnSql('user_data', 'turbo_bonus', 'FLOAT(20,3) NOT NULL DEFAULT 0.000');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Login-Bonus und Turbo-Klick-Bonus intergriert.");
				break;

			case '0.2.2': // SQL queries for v0.2.2
				addDropTableSql('bonus_turbo');
				addCreateTableSql('bonus_turbo', "
`id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`userid` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`mail_id` BIGINT(20) UNSIGNED NULL DEFAULT NULL,
`bonus_id` BIGINT(20) UNSIGNED NULL DEFAULT NULL,
`level` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`points` FLOAT(20,3) NOT NULL DEFAULT 0.000,
`timemark` VARCHAR(32) NOT NULL DEFAULT 0,
PRIMARY KEY (`id`),
INDEX `mail_id` (`mail_id`),
INDEX `bonus_id` (`bonus_id`),
INDEX `userid` (`userid`)",
					'Fastest click rallye table');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Turbo-Bonus wird in Tabelle gez&auml;hlt f&uuml;r Anzeige, wer alles bereits geklickt hat und welchen Platz er gemacht hat.");
				break;

			case '0.2.3': // SQL queries for v0.2.3
				addExtensionSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_member_menu` WHERE `what`='bonus' LIMIT 1");
				addMemberMenuSql('main', 'bonus', 'Aktiv-Rallye', 7);

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Aktiv-Rallye mit Klick-Verg&uuml;tung hinzugef&uuml;gt.");
				break;

			case '0.2.4': // SQL queries for v0.2.4
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Wegen des Theme-Supportes hat sich die URL zur CSS-Datei ge&auml;ndert.");
				break;

			case '0.2.5': // SQL queries for v0.2.5
				addDropTableSql('bonus_urls');
				addDropTableSql('bonus_customer');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Tabellen <u>{?_MYSQL_PREFIX?}_bonus_urls</u> und <u>{?_MYSQL_PREFIX?}_bonus_customer</u> entfernt, da dies bald von der Erweiterung <u>sponsor</u> erledigt wird.");
				break;

			case '0.2.6': // SQL queries for v0.2.6
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Fehler beseitigt, wenn error_reporting=E_ALL gesetzt ist.");
				break;

			case '0.2.7': // SQL queries for v0.2.7
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Turbo-Bonus klappt wieder (dies sind {?POINTS?} die an die schnellsten Klicker verg&uuml;tet werden!)");
				break;

			case '0.2.8': // SQL queries for v0.2.8
				addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_bonus` SET `timestamp`=0 WHERE `timestamp`='0000000000'");
				addExtensionChangeTableColumnSql('bonus_turbo', 'points', 'points', 'FLOAT(20,5) UNSIGNED NOT NULL DEFAULT 0.00000');
				addExtensionChangeTableColumnSql('user_data', 'turbo_bonus', 'turbo_bonus', 'FLOAT(20,5) UNSIGNED NOT NULL DEFAULT 0.00000');
				addExtensionChangeTableColumnSql('user_data', 'login_bonus', 'login_bonus', 'FLOAT(20,5) UNSIGNED NOT NULL DEFAULT 0.00000');

				// For configuration, we need different entries
				addExtensionAddTableColumnSql('user_data', 'turbo_bonus', 'turbo_bonus', 'FLOAT(20,5) UNSIGNED NOT NULL DEFAULT 0.00000');
				addExtensionAddTableColumnSql('user_data', 'login_bonus', 'login_bonus', 'FLOAT(20,5) UNSIGNED NOT NULL DEFAULT 0.00000');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("5 Nachkommastellen implementiert");
				break;

			case '0.2.9': // SQL queries for v0.2.9
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Problem mit Speicherung der Einstellungen beseitigt.");
				break;

			case '0.3.0': // SQL queries for v0.3.0
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Men&uuml;punkte im Gast-/Mitgliedsbereich k&ouml;nnen nicht mehr aufgerufen werden, wenn die Erweiterung deaktiviert ist.");
				break;

			case '0.3.1': // SQL queries for v0.3.1
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Sicherheitsupdate am Script <u>show_bonus.php</u> durchgef&uuml;hrt.");
				break;

			case '0.3.2': // SQL queries for v0.3.2
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Design &quot;Solid-Business&quot; eingebaut.");
				break;

			case '0.3.3': // SQL queries for v0.3.3
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Seit <strong>Patch 340</strong> &uuml;berfl&uuml;ssige HTML-Tags entfernt.");
				break;

			case '0.3.4': // SQL queries for v0.3.4
				addAdminMenuSql('user', 'list_bonus', 'Aktiv-Rallye-Teilnehmer', 'Listet alle Mitglieder auf, die einen Aktiv-Bonus haben und zeigt die derzeit m&ouml;glichen Gewinner an.', 10);

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Link <u>Aktiv-Rallye-Teilnehmer</u> hinzugef&uuml;gt, inklusive manuelle Vorbereitung der Verg&uuml;tung.");
				break;

			case '0.3.5': // SQL queries for v0.3.5
				addConfigAddSql('bonus_mode', "ENUM('UID','JACKPOT','ADD') NOT NULL DEFAULT 'ADD'");
				addConfigAddSql('bonus_userid', 'BIGINT(20) UNSIGNED NOT NULL DEFAULT 0');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Der Login-Bonus Aktiv-Bonus (= Klick-Bonus) k&ouml;nnen nun zuerst von einem Mitgliederaccount (das sollte Ihres sein!), vom Jackpot abgezogen oder einfach dazuadiert werden.");
				break;

			case '0.3.6': // SQL queries for v0.3.6
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("In der Admin-Liste werden nur aktive Mitglieder gelistet und zudem die sp&auml;teste Zeitmarke f&uuml;r die Auswertung angezeigt.");
				break;

			case '0.3.7': // SQL queries for v0.3.7
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Mitgliedaccount auw&auml;hlbar, von dem die {?POINTS?} f&uuml;r den Aktiv- und Login-Bonus abgebucht werden.");
				break;

			case '0.3.8': // SQL queries for v0.3.8
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Ausgabe des generierten HTML-Codes nach <u>inc/footer.php</u> verlagert.");
				break;

			case '0.3.9': // SQL queries for v0.3.9
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Fehlende Variablen gefixt.");
				break;

			case '0.4.0': // SQL queries for v0.4.0
				addConfigAddSql('bonus_timeout', 'BIGINT(20) UNSIGNED NOT NULL DEFAULT ' . (getOneDay() * 7));
				addConfigAddSql('bonus_lines', 'BIGINT(20) UNSIGNED NOT NULL DEFAULT 10');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Automatisches L&ouml;schen von Turbo-Bonus-Zeilen ({?_MYSQL_PREFIX?}_bonus_turbo) und begrenzte Anzahl von Eintr&auml;gen hinzugef&uuml;gt.");
				break;

			case '0.4.1': // SQL queries for v0.4.1
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Verg&uuml;tung des Aktiv-Bonus repariert.");
				break;

			case '0.4.2': // SQL queries for v0.4.2
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Admin-Bereich / Aktiv-Teilnehmer auflisten: Problem mit Konstante __AUTOPURGE_TIMEOUT und das Template <u>admin_list_bonus.tpl</u> korregiert.");
				break;

			case '0.4.3': // SQL queries for v0.4.3
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Verbesserung des Versandes von  HTML-Bonus-Mails.");
				break;

			case '0.4.4': // SQL queries for v0.4.4
				addConfigAddSql('bonus_order', 'FLOAT(20,5) UNSIGNED NOT NULL DEFAULT 15.00000');
				addConfigAddSql('bonus_ref', 'FLOAT(20,5) UNSIGNED NOT NULL DEFAULT 100.00000');
				addConfigAddSql('bonus_stats', 'FLOAT(20,5) UNSIGNED NOT NULL DEFAULT 5.00000');
				addConfigAddSql('bonus_active', "ENUM('Y','N') NOT NULL DEFAULT 'Y'");
				addExtensionAddTableColumnSql('user_data', 'bonus_order', 'FLOAT(20,5) UNSIGNED NOT NULL DEFAULT 0.00000');
				addExtensionAddTableColumnSql('user_data', 'bonus_ref', 'FLOAT(20,5) UNSIGNED NOT NULL DEFAULT 0.00000');
				addExtensionAddTableColumnSql('user_data', 'bonus_stats', 'FLOAT(20,5) UNSIGNED NOT NULL DEFAULT 0.00000');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Bonus-{?POINTS?} f&uuml;r: Mailbuchung, Referral-Werbung (bei Best. der EMail-Adresse) und wenn 100% Klickrate jeder Mailbuchung erreicht wurde.<br />Template <u>admin_config_bonus_pro.tpl</u> ist &uuml;berfl&uuml;ssig geworden. Bitte l&ouml;schen Sie dies!<br />Eingestellte Bonus-{?POINTS?} f&uuml;r Rank 2 war um eins verschoben.");
				break;

			case '0.4.5': // SQL queries for v0.4.5
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Abzug vom Bonus-Account integriert.");
				break;

			case '0.4.6': // SQL queries for v0.4.6
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Rank 2 bekommt nun auch seine {?POINTS?} gutgeschrieben.");
				break;

			case '0.4.7': // SQL queries for v0.4.7
				addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_user_data` SET `login_bonus`=0,`turbo_bonus`=0,`bonus_ref`=0,`bonus_order`=0,`bonus_stats`=0");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Die Aktiv-Rallye wurde nicht auf 0 {?POINTS?} gesetzt. Dieser Fehler ist nun behoben. Allerdings ist mit diesem Update auch die Aktiv-Rallye zur&uuml;ckgesetzt worden.");
				break;

			case '0.4.8': // SQL queries for v0.4.8
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("In <u>inc/monthly_bonus.php</u> fehlte ein Punkt; Fehler besseitigt.");
				break;

			case '0.4.9': // SQL queries for v0.4.9
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Login-Bonus wird mit angezeigt.");
				break;

			case '0.5.0': // SQL queries for v0.5.0
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Problem mit <strong>is_hundred</strong> beim t&auml;glichen Reset beseitigt.");
				break;

			case '0.5.1': // SQL queries for v0.5.1
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Problem mit <strong>bonus_stats / Zeile 31</strong> beim t&auml;glichen Reset beseitigt.");
				break;

			case '0.5.2': // SQL queries for v0.5.2
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("W&ouml;rter <strong>{?mt_word?}</strong>, <strong>{?mt_word2?}</strong> und <strong>{?mt_word3?}</strong> sind austauschbar.");
				break;

			case '0.5.3': // SQL queries for v0.5.3
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Speichern der Aktiv-{?POINTS?} f&uuml;r Platz 2 bis <strong>x</strong> korregiert.");
				break;

			case '0.5.4': // SQL queries for v0.5.4
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Variablenfehler in <strong>inc/monthly_bonus.php</strong> behoben.");
				break;

			case '0.5.5': // SQL queries for v0.5.5
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Weitere Variablenfehler in <strong>inc/monthly_bonus.php</strong> haben daf&uuml;r gesorgt, dass die monatliche Aktiv-Rallye nicht ausgesch&uuml;ttet wurde. Mit diesem Update wurde die Aussch&uuml;ttung initialisiert. Ihre Mitglieder bekommen voraussichtlicht nichts doppelt verg&uuml;tet.");
				break;

			case '0.5.6': // SQL queries for v0.5.6
				// Get current month
				$curr = padLeftZero(getMonth());
				if ($curr == '00') $curr = '12';

				// Generate timemark...
				$mark = mktime(0, 0, 0, $curr, 1, getYear());

				// Update accounts which are not active last months
				addExtensionSql('UPDATE
	`{?_MYSQL_PREFIX?}_user_data`
SET
	`turbo_bonus`=0,
	`login_bonus`=0,
	`bonus_order`=0,
	`bonus_stats`=0,
	`bonus_ref`=0
WHERE
	`last_online` < ' . $mark . '
ORDER BY
	`userid` ASC');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Ein weiterer Scriptfehler hat nur die Gewinner aus der Aktiv-Rallye genommen. Die anderen Mitglieder sind somit &quot;nach oben gerutsch&quot;.");
				break;

			case '0.5.7': // SQL queries for v0.5.7
				break;

			case '0.5.8': // SQL queries for v0.5.8
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Problem mit <strong>is_hundred</strong> beim t&auml;glichen Reset endlich beseitigt.");
				break;

			case '0.5.9': // SQL queries for v0.5.9
				setExtensionUpdateNotes("Fehlermeldung <strong>/home/verzeichnis/html/inc/stats_bonus.php (42):You have an error in your SQL syntax. Check the manual that corresponds to your MySQL server version for the right syntax to use near '' WHERE userid='59' LIMIT 1' at line 1</strong> beseitigt.");
				break;

			case '0.6.0': // SQL queries for v0.6.0
				setExtensionUpdateNotes("SQL-Fehlermeldung in <strong>inc/monthly_bonus.php</strong> beseitigt.");
				break;

			case '0.6.1': // SQL queries for v0.6.1
				setExtensionUpdateNotes("Versand von Bonus-Mails repariert.");
				break;

			case '0.6.2': // SQL queries for v0.6.2
				setExtensionUpdateNotes("L&ouml;schen von bereits gel&ouml;schten Mails wird nun abgelehnt.");
				break;

			case '0.6.3': // SQL queries for v0.6.3
				setExtensionUpdateNotes("Abspeichern von Einstellungen repariert.");
				break;

			case '0.6.4': // SQL queries for v0.6.4
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Der Men&uuml;punkt &quot;Bonus-{?POINTS?}&quot; unter Einstellungen wird nach &quot;Aktiv-Rallye umbenannt. Und die Aktiv-Rallye konnte aufgrund eines Template-Fehlers nicht gespeichert werden.");
				break;

			case '0.6.5': // SQL queries for v0.6.5
				addExtensionAddTableColumnSql('user_stats', 'bonus_stats', "ENUM('Y','N') NOT NULL DEFAULT 'N'");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Fehler mit bonus_stats beseitigt.");
				break;

			case '0.6.6': // SQL queries for v0.6.6
				setExtensionUpdateNotes("Template-Fehler beseitigt im Admin-Bereich.");
				break;

			case '0.6.7': // SQL queries for v0.6.7
				setExtensionUpdateNotes("Vorbereitung auf die neue Mediendaten v0.0.4.");
				break;

			case '0.6.8': // SQL queries for v0.6.8
				addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_bonus` SET `data_type`='SEND' WHERE `data_type` != 'SEND' AND `data_type` != 'DELETED' AND `receivers`='' AND `target_send`=0");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Eingegebene Anzahl auszusendener Bonus-Mails wurde bei der Empf&auml;nderauswahl nicht ber&uuml;cksichtigt. Zudem wird jetzt das eingestellte Auswahlverfahren mitber&uuml;cksichtigt.");
				break;

			case '0.6.9': // SQL queries for v0.6.9
				addConfigAddSql('include_bonus_order', "ENUM('Y','N') NOT NULL DEFAULT 'N'");
				addConfigAddSql('include_bonus_ref', "ENUM('Y','N') NOT NULL DEFAULT 'N'");
				addConfigAddSql('include_bonus_stats', "ENUM('Y','N') NOT NULL DEFAULT 'N'");
				addConfigAddSql('include_bonus_login', "ENUM('Y','N') NOT NULL DEFAULT 'N'");
				addConfigAddSql('include_bonus_click', "ENUM('Y','N') NOT NULL DEFAULT 'Y'");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Es k&ouml;nnen nun auch die folgenden Verg&uuml;tungen bei der Auswertung der monatlichen Aktiv-Rallye mit ber&uuml;cksichtigt werden: Mailbest&auml;tigung (war vorher schon), Login-, Mailbuchung, Referral und Statistik-Bonus (100% Klickrate erreicht).");
				break;

			case '0.7.0': // SQL queries for v0.7.0
				setExtensionUpdateNotes("Zuschaltung von weiteren Bonis wird jetzt auch bei der Auflistung der mitmachenden Mitglieder im Mitgliedsbereich beachtet.");
				break;

			case '0.7.1': // SQL queries for v0.7.1
				setExtensionUpdateNotes("Im Adminbereich wird nun ebenfalls die Zuschaltung von weiteren Bonis ber&uuml;cksichtigt. Zudem wird der Gesamtbonus an alle Mitglieder errechnet und auch angezeigt.");
				break;

			case '0.7.2': // SQL queries for v0.7.2
				setExtensionUpdateNotes("Die Verg&uuml;tung der erreichten 100%-Klickrate war noch wegen Programmierungen am Script auskommentiert. Sorry!");
				break;

			case '0.7.3': // SQL queries for v0.7.3
				setExtensionUpdateNotes("Gutgeschriebene Bonus-{?POINTS?} werden nach Deaktivierung der Aktiv-Rallye gel&ouml;scht.");
				break;

			case '0.7.4': // SQL queries for v0.7.4
				setExtensionUpdateNotes("Rechtlichen Hinweis im Mitgliedsbereich vergessen. (<strong>member_bonus.tpl</strong>)");
				break;

			case '0.7.5': // SQL queries for v0.7.5
				setExtensionUpdateNotes("Im Admin-Bereich Hinweis hinzugef&uuml;gt, wenn Aktiv-Rallye inaktiv ist. Bitte Script inc/monthly_bonus.php l&ouml;schen!");
				break;

			case '0.7.6': // SQL queries for v0.7.6
				setExtensionUpdateNotes("Auswahlmechanismus der Gewinner repariert. Trotz Hinzuschalten von weiteren zu ber&uuml;cksichtigen Boni wurden diese bei der Sortierung der Mitglieds-Ids nicht ber&uuml;cksichtig.");
				break;

			case '0.7.7': // SQL queries for v0.7.7
				addConfigAddSql('bonus_enable_notify', "ENUM('Y','N') NOT NULL DEFAULT 'N'");
				addConfigAddSql('bonus_disable_notify', "ENUM('Y','N') NOT NULL DEFAULT 'N'");
				addConfigAddSql('bonus_new_member_notify', "ENUM('Y','N') NOT NULL DEFAULT 'N'");
				addConfigAddSql('bonus_notify_points', 'FLOAT(20,5) UNSIGNED NOT NULL DEFAULT 0.00000');
				addConfigAddSql('bonus_notify_wait', 'BIGINT(20) UNSIGNED NOT NULL DEFAULT 30');
				addExtensionAddTableColumnSql('user_data', 'bonus_ral_en_notify', 'BIGINT(20) UNSIGNED NOT NULL DEFAULT 0');
				addExtensionAddTableColumnSql('user_data', 'bonus_ral_di_notify', 'BIGINT(20) UNSIGNED NOT NULL DEFAULT 0');
				addExtensionAddTableColumnSql('user_data', 'bonus_ral_notify', 'BIGINT(20) UNSIGNED NOT NULL DEFAULT 0');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Optionale automatische Benachrichtigung &uuml;ber aktivierte und/oder deaktivierte Aktiv-Rallye einstellbar.");
				break;

			case '0.7.8': // SQL queries for v0.7.8
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Fehler im t&auml;glichen Reset beseitigt.");
				break;

			case '0.7.9': // SQL queries for v0.7.9
				setExtensionUpdateNotes("Dollarzeichen fehlte in <strong>inc/daily/daily_bonus.php</strong>, Zeile 39");
				break;

			case '0.8.0': // SQL queries for v0.8.0
				setExtensionUpdateNotes("De-/Aktivieren des mit dieser Erweiterung verkn&uuml;pften Modules eingebunden.");
				break;

			case '0.8.1': // SQL queries for v0.8.1
				setExtensionUpdateNotes("Bei {?POINTS?}-Gleichstand wird als n&auml;chstes nach wer als letztes Online war umsortiert.");
				break;

			case '0.8.2': // SQL queries for v0.8.2
				addConfigAddSql('bonus_include_own', "ENUM('Y','N') NOT NULL DEFAULT 'N'");
				addExtensionAddTableColumnSql('bonus', 'is_notify', "ENUM('Y','N') NOT NULL DEFAULT 'N'");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Eigene Mitglieds-Ids sind von der Aktiv-Rallye nun ausschliessbar. Benachrichtigungsmails sind von Aktiv-Rallye ausgeschlossen.");
				break;

			case '0.8.3': // SQL queries for v0.8.3
				addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_member_menu` SET `action`='rals',`sort`=2,`title`='Aktiv-Rallye' WHERE `what`='bonus' LIMIT 1");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Mitgliedsmen&uuml; komplett umgebaut.");
				break;

			case '0.8.4': // SQL queries for v0.8.4
				setExtensionUpdateNotes("Ladeproblem bei nicht installierter Erweiterung <strong>cache</strong> gefixt.");
				break;

			case '0.8.5': // SQL queries for v0.8.5
				setExtensionUpdateNotes("CSS-Klassenname gefixt in Templates.");
				break;

			case '0.8.6': // SQL queries for v0.8.6
				setExtensionUpdateNotes("Fehlerhinweis bei deaktivierter Erweiterung verbessert.");
				break;

			case '0.8.7': // SQL queries for v0.8.7
				addAdminMenuSql('email','list_notifications','Benachrichtigungen','Listet alle an die Mitglieder ausgesandten Benachrichtigungen auf.', 10);

				// Update notes
				setExtensionUpdateNotes("Benachrichtigungsmails f&uuml;r z.B. Bettel- oder Aktiv-Rallye werden nun angezeigt.");
				break;

			case '0.8.8': // SQL queries for v0.8.8
				addExtensionAddTableColumnSql('user_stats', 'bonus_stats_active', "ENUM('Y','N') NOT NULL DEFAULT 'N'");

				// Update notes
				setExtensionUpdateNotes("Benachrichtigungsmails f&uuml;r z.B. Bettel- oder Aktiv-Rallye werden nun angezeigt.");
				break;

			case '0.8.9': // SQL queries for v0.8.9
				addAdminMenuSql('setup','config_bonus','Aktiv-Rallye','Richten Sie eine komplette Aktiv-Rallye hier ein. Legen Sie Verg&uuml;tungen fest, die die Mitglieder f&uuml;r bestimmte Aktionen auf ihr Aktiv-Konto gutgeschrieben bekommen sollen.',8);

				// Update notes
				setExtensionUpdateNotes("Benachrichtigungsmails f&uuml;r z.B. Bettel- oder Aktiv-Rallye werden nun angezeigt.");
				break;

			case '0.9.0': // SQL queries for v0.9.0
				// Register filter
				registerFilter(__FILE__, __LINE__, 'member_login_check', 'ADD_LOGIN_BONUS', FALSE, TRUE, isExtensionDryRun());

				// Update notes
				setExtensionUpdateNotes("Filter hinzugef&uuml;gt der den Login-Bonus aktualisiert (bzw. soll) (internes TODO).");
				break;

			case '0.9.1': // SQL queries for v0.9.1
				addConfigChangeSql('bonus_en_notify', 'bonus_enable_notify', "ENUM('Y','N') NOT NULL DEFAULT 'N'");
				addConfigChangeSql('bonus_di_notify', 'bonus_disable_notify', "ENUM('Y','N') NOT NULL DEFAULT 'N'");
				addConfigChangeSql('bonus_new_mem_notify', 'bonus_new_member_notify', "ENUM('Y','N') NOT NULL DEFAULT 'N'");

				// Update notes
				setExtensionUpdateNotes("Umbenannt nach neuer Konvention (bitte Einstellungen kontrollieren).");
				break;

			case '0.9.2': // SQL queries for v0.9.2
				addExtensionChangeTableColumnSql('user_data', 'bonus_ral_en_notify', 'bonus_ralley_enable_notify', 'BIGINT(20) UNSIGNED NOT NULL DEFAULT 0');
				addExtensionChangeTableColumnSql('user_data', 'bonus_ral_di_notify', 'bonus_ralley_disable_notify', 'BIGINT(20) UNSIGNED NOT NULL DEFAULT 0');
				addExtensionChangeTableColumnSql('user_data', 'bonus_ral_notify', 'bonus_rallley_notify', 'INT(20)', 'UNSIGNED NOT NULL DEFAULT 0');

				// Update notes
				setExtensionUpdateNotes("Umbenannt nach neuer Konvention (bitte Einstellungen kontrollieren).");
				break;

			case '0.9.3': // SQL queries for v0.9.3
				addExtensionChangeTableColumnSql('user_data', 'bonus_ralley_enable_notify', 'bonus_rallye_enable_notify', 'BIGINT(20) UNSIGNED NOT NULL DEFAULT 0');
				addExtensionChangeTableColumnSql('user_data', 'bonus_ralley_disable_notify', 'bonus_rallye_disable_notify', 'BIGINT(20) UNSIGNED NOT NULL DEFAULT 0');
				addExtensionDropTableColumnSql('user_data', 'bonus_ralley_notify');

				// Update notes
				setExtensionUpdateNotes("Typos gefixt.");
				break;

			case '0.9.4': // SQL queries for v0.9.4
				addExtensionChangeTableColumnSql('user_links', 'bonus_id', 'bonus_id', 'BIGINT(20) UNSIGNED NULL DEFAULT NULL');
				addExtensionSql('UPDATE `{?_MYSQL_PREFIX?}_user_links` SET `bonus_id`=NULL WHERE `bonus_id`=0');

				// Update notes
				setExtensionUpdateNotes("Konfliktierende SQL-Befehle aus ext-user verschoben.");
				break;

			case '0.9.5': // SQL queries for v0.9.5
				// Register filter
				registerFilter(__FILE__, __LINE__, 'generate_admin_mail_links', 'GENERATE_BONUS_MAIL_LINKS', FALSE, TRUE, isExtensionDryRun());

				// Update notes
				setExtensionUpdateNotes("Filter zum Generieren von Admin-Links f&uuml;r Bonus-Mails hinzugef&uuml;gt.");
				break;

			case '0.9.6': // SQL queries for v0.9.6
				// Register points data
				registerExtensionPointsData('monthly_bonus', 'points', 'LOCKED', 'DIRECT');

				// Update notes
				setExtensionUpdateNotes("Monatlicher Bonus wird nun &uuml;ber die Tabelle <strong>{OPEN_CONFIG}_MYSQL_PREFIX{CLOSE_CONFIG}_points_data</strong> verwaltet.");
				break;

			case '0.9.7': // SQL queries for v0.9.7
				addConfigChangeSql('bonus_order_yn', 'include_bonus_order', "ENUM('Y','N') NOT NULL DEFAULT 'N'");
				addConfigChangeSql('bonus_ref_yn'  , 'include_bonus_ref'  , "ENUM('Y','N') NOT NULL DEFAULT 'N'");
				addConfigChangeSql('bonus_stats_yn', 'include_bonus_stats', "ENUM('Y','N') NOT NULL DEFAULT 'N'");
				addConfigChangeSql('bonus_login_yn', 'include_bonus_login', "ENUM('Y','N') NOT NULL DEFAULT 'N'");
				addConfigChangeSql('bonus_click_yn', 'include_bonus_click', "ENUM('Y','N') NOT NULL DEFAULT 'Y'");

				// Register filter
				registerFilter(__FILE__, __LINE__, 'add_bonus_points_user_columns', 'ADD_BONUS_POINTS_USER_COLUMNS', FALSE, TRUE, isExtensionDryRun());

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Konfigurationseintr&auml;ge umbenannt.");
				break;

			case '0.9.8': // SQL queries for v0.9.8
				// Register filter
				registerFilter(__FILE__, __LINE__, 'pre_user_registration', 'BONUS_USER_REGISTRATION_ADD_SQL_COLUMNS', FALSE, TRUE, isExtensionDryRun());

				// Add dependency to ext-register
				addExtensionDependency('register');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Filter zum Hinzuf&uuml;gen von SQL-Spalten bei der Mitgliederanmeldung.");
				break;

			case '0.9.9': // SQL queries for v0.9.9
				// Register filter
				registerFilter(__FILE__, __LINE__, 'init', 'SEND_BONUS_NOTIFICATIONS', FALSE, TRUE, isExtensionDryRun());

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Filter zum Hinzuf&uuml;gen von SQL-Spalten bei der Mitgliederanmeldung.");
				break;

			case '1.0.0': // SQL queries for v1.0.0
				addExtensionChangeTableColumnSql('bonus_turbo', 'mail_id' , 'mail_id', 'UNSIGNED NULL DEFAULT NULL');
				addExtensionChangeTableColumnSql('bonus_turbo', 'bonus_id', 'mail_id', 'UNSIGNED NULL DEFAULT NULL');

				// Register filter
				registerFilter(__FILE__, __LINE__, 'config_userid_exclusion_sql', 'EXLCUDE_BONUS_USERID', FALSE, TRUE, isExtensionDryRun());

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Filter zum Ausschlie&szlig;en des konfigurierten Mitgliedaccounts.");
				break;
		} // END - switch

// [EOF]
?>
