<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 01/14/2005 *
 * ===================                          Last change: 01/14/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : ext-online.php                                   *
 * -------------------------------------------------------------------- *
 * Short description : Who is where online?                             *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Wer befindet sich wo gerade Online?              *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2013 by Mailer Developer Team                   *
 * For more information visit: http://mxchange.org                      *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} // END - if

// Version number
setThisExtensionVersion('0.0.6');

// Version history array (add more with , '0.0.1' and so on)
setExtensionVersionHistory(array('0.0.0', '0.0.1', '0.0.2', '0.0.3', '0.0.4', '0.0.5', '0.0.6'));

switch (getExtensionMode()) {
	case 'setup': // Do stuff when installation is running
		// "Who-is-where" table
		addDropTableSql('online');
		addCreateTableSql('online', "
`id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`sid` VARCHAR(32) NOT NULL DEFAULT '',
`ip` VARCHAR(15) NOT NULL DEFAULT '',
`userid` BIGINT(20) UNSIGNED NULL DEFAULT NULL,
`refid` BIGINT(20) UNSIGNED NULL DEFAULT NULL,
`module` VARCHAR(255) NOT NULL DEFAULT '',
`action` VARCHAR(255) NOT NULL DEFAULT '',
`what` VARCHAR(255) NOT NULL DEFAULT '',
`is_admin` ENUM('Y','N') NOT NULL DEFAULT 'N',
`is_member` ENUM('Y','N') NOT NULL DEFAULT 'N',
`timestamp` VARCHAR(10) NOT NULL DEFAULT 0,
PRIMARY KEY (`id`),
INDEX (`userid`),
INDEX (`refid`),
INDEX `admin_member` (`is_admin`, `is_member`)",
			'Who-is-where data');

		// Admin menu
		addAdminMenuSql('misc','usr_online','Online-Statistik','Eine Liste von derzeit &quot;Online&quot; Usern. Doppelte Eintr&auml;ge k&ouml;nnte auf mangelnden Cookie-Support des Browsers oder auf einen Spider hindeuten.', 1);
		break;

	case 'remove': // Do stuff when removing extension
		// SQL commands to run
		addDropTableSql('online');
		addExtensionSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_admin_menu` WHERE `what`='usr_online'");
		addExtensionSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_guest_menu` WHERE `action`='online'");

		// Unregister filter
		unregisterFilter(__FILE__, __LINE__, 'init', 'UPDATE_ONLINE_LIST', TRUE, isExtensionDryRun());
		break;

	case 'activate': // Do stuff when admin activates this extension
		// SQL commands to run
		addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_guest_menu` SET `visible`='Y',`locked`='N' WHERE `action`='online' LIMIT 1");
		break;

	case 'deactivate': // Do stuff when admin deactivates this extension
		// SQL commands to run
		addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_guest_menu` SET `visible`='N',`locked`='Y' WHERE `action`='online' LIMIT 1");
		break;

	case 'update': // Update an extension
		switch (getCurrentExtensionVersion()) {
			case '0.0.1': // SQL queries for v0.0.1
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Fehler <u>Unknown column 'visibled' in 'field list'</u> behoben.");
				break;

			case '0.0.2': // SQL queries for v0.0.2
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Seit <strong>Patch 340</strong> &uuml;berfl&uuml;ssige HTML-Tags entfernt.");
				break;

			case '0.0.3': // SQL queries for v0.0.3
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("HTML-Code ausgelagert in Templates und SQL-Anweisungen abgesichert.");
				break;

			case '0.0.4': // SQL queries for v0.0.4
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Erstellung der Datenbanktabelle `{?_MYSQL_PREFIX?}_online` in diese Erweiterung ausgelagert.");
				break;

			case '0.0.5': // SQL queries for v0.0.5
				// Add guest menu
				addGuestMenuSql('online', NULL, 'Jetzt Online', 2);

				// Register filter
				registerFilter(__FILE__, __LINE__, 'init', 'UPDATE_ONLINE_LIST', FALSE, TRUE, isExtensionDryRun());

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Hinzuf&uuml;gen des Men&uuml;punktes &quot;Jetzt Online&quot; wird nun von dieser Erweiterung erledigt. Filter hinzugef&uuml;gt.");
				break;

			case '0.0.6': // SQL queries for v0.0.6
				addExtensionChangeTableColumnSql('online', 'userid', 'userid', 'BIGINT(20) UNSIGNED NULL DEFAULT NULL');
				addExtensionChangeTableColumnSql('online', 'refid', 'refid', 'BIGINT(20) UNSIGNED NULL DEFAULT NULL');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Spalten userid und refid erlauben nun <stron>null</strong>.");
				break;
		} // END - switch
		break;

	case 'modify': // When the extension got modified
		break;

	case 'test': // For testing purposes
		break;

	case 'init': // Do stuff when extension is initialized
		break;

	default: // Unknown extension mode
		reportBug(__FILE__, __LINE__, sprintf("Unknown extension mode %s in extension %s detected.", getExtensionMode(), getCurrentExtensionName()));
		break;
} // END - switch

// [EOF]
?>
