<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 02/29/2004 *
 * ===================                          Last change: 04/23/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-support.php                                 *
 * -------------------------------------------------------------------- *
 * Short description : Contact support                                  *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Support kontaktieren                             *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2013 by Mailer Developer Team                   *
 * For more information visit: http://mxchange.org                      *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	exit();
}  elseif (!isMember()) {
	redirectToIndexMemberOnlyModule();
}

// Add description as navigation point
addYouAreHereLink('member', __FILE__);

if ((!isExtensionActive('support')) && (!isAdmin())) {
	displayMessage('{%pipe,generateExtensionInactiveNotInstalledMessage=support%}');
	return;
} // END - if

if ((!isFormSent()) || (!isPostRequestElementSet('qsummary'))) {
	// Output form
	loadTemplate('member_support_form');
} else {
	// Load mail template based on your member's decision
	if (isExtensionInstalledAndNewer('admins', '0.4.1')) {
		$a_tpl = 'admin_support-' . postRequestElement('qsummary');
	} else {
		$message_a = loadEmailTemplate('admin_support-' . postRequestElement('qsummary'), array('text' => postRequestElement('qdetails')), getMemberId());
	}
	$message_m = loadEmailTemplate('member_support-' . postRequestElement('qsummary'), array('text' => postRequestElement('qdetails')), getMemberId());

	// Select right subject
	switch (postRequestElement('qsummary')) {
		case 'ordr':
			$subj_a = '{--ADMIN_SUPPORT_ORDER_SUBJECT--}';
			$subj_m = '{--MEMBER_SUPPORT_ORDER_SUBJECT--}';
			break;

		case 'reflink':
			$subj_a = '{--ADMIN_SUPPORT_REFERRAL_LINK_SUBJECT--}';
			$subj_m = '{--MEMBER_SUPPORT_REFERRAL_LINK_SUBJECT--}';
			break;

		case 'unconfirmed':
			$subj_a = '{--ADMIN_SUPPORT_UNCONFIRMED_SUBJECT--}';
			$subj_m = '{--MEMBER_SUPPORT_UNCONFIRMED_SUBJECT--}';
			break;
	} // END - switch

	// Send mail to admin
	sendAdminNotification($subj_a, $a_tpl, array('text' => postRequestElement('qdetails')), getMemberId());

	// Send mail to user
	sendEmail(getMemberId(), $subj_m, $message_m);

	// Drop a message in the admin's area (we ignore the task id here)
	createNewTask($subj_a, postRequestElement('qsummary') . ' : ' . postRequestElement('qdetails'), 'MEMBER_SUPPORT', getMemberId());

	// Form sent
	loadTemplate('member_support_contcted');
}

// [EOF]
?>
